# $Revision: 1.143 $, $Date: 2009/04/03 14:36:56 $
# TODO
# - bittorrent complete doesn't actually handle our prognames
# - handle multiple package links (freeciv case)
# - handle upgrade path to symlinks (see notes in install section)
Summary:	bash-completion offers programmable completion for bash
Summary(pl.UTF-8):	Programowalne uzupełnianie nazw dla basha
Name:		bash-completion
Version:	20081219
Release:	2
License:	GPL
Group:		Applications/Shells
Source0:	ftp://distfiles.gentoo.org/pub/gentoo/distfiles/%{name}-%{version}.tar.bz2
# Source0-md5:	6b8f924417fb8cd758778025d97f2853
Source1:	%{name}-poldek.sh
Source2:	%{name}.sh
Patch0:		%{name}-rpm-cache.patch
Patch1:		%{name}-mplayer.patch
URL:		http://bash-completion.alioth.debian.org/
Requires(triggerpostun):	sed >= 4.0
Requires:	bash >= 2.05a-3
Obsoletes:	bash-completion-rpm-cache
Conflicts:	rpm < 4.4.9-44
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
bash-completion is a collection of shell functions that take advantage
of the programmable completion feature of bash 2.04 and later.

%description -l pl.UTF-8
bash-completion jest kolekcją funkcji shella, które opierają się na
wbudowanych rozszerzeniach basha 2.04 lub późniejszego umożliwiającego
kompletowanie parametrów linii poleceń.

%prep
%setup -q -n %{name}
%patch0 -p1
%patch1 -p1
cp -a %{SOURCE1} contrib/poldek

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

# packaged by subversion.spec
rm contrib/_subversion

# No package matches '*/apache2ctl'
rm contrib/apache2ctl

# No PLD package or no such binary to complete on
rm contrib/{harbour,larch,lisp,modules,monodevelop,p4}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir}/bash_completion.d,/etc/shrc.d,%{_datadir}/%{name}}

T=$(grep -c '^%%bashcomp_trigger' %{_specdir}/%{name}.spec)
F=$(grep -c '^%%{_datadir}/%%{name}/' %{_specdir}/%{name}.spec)
if [ $T != $F ]; then
	check_triggers() {
		echo >&2 "ERROR: triggers count and packaged files mismatch"
		for f in $(awk '/^%%bashcomp_trigger/{print $3 ? $3 : $2}' %{_specdir}/%{name}.spec); do
			A=$(awk -vf=$f '$0 == "%%{_datadir}/%%{name}/" f {print}' %{_specdir}/%{name}.spec)
			if [ -z "$A" ]; then
				echo >&2 "!! $f not listed in %%files"
			fi
		done
		for f in $(awk -F/ '$0 ~ "^%%{_datadir}/%%{name}/"{print $NF}' %{_specdir}/%{name}.spec); do
			A=$(awk -vf=$f '/^%%bashcomp_trigger/ && ($3 ? $3 : $2) == f' %{_specdir}/%{name}.spec)
			if [ -z "$A" ]; then
				echo >&2 "!! $f has no trigger"
			fi
		done
	}
	check_triggers
	exit 1
fi

cp -a bash_completion $RPM_BUILD_ROOT%{_sysconfdir}
cp -a contrib/* $RPM_BUILD_ROOT%{_datadir}/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT/etc/shrc.d

# Take care of contrib files
for a in contrib/*; do
	f=${a##*/}
	ln -s %{_datadir}/%{name}/$f $RPM_BUILD_ROOT%{_sysconfdir}/bash_completion.d
	echo "%ghost %{_sysconfdir}/bash_completion.d/$f"
done > %{name}-ghost.list

%clean
rm -rf $RPM_BUILD_ROOT

%triggerpostun -- %{name} < 20050721-3.9
sed -i -e '/^# START bash completion/,/^# END bash completion/d' /etc/bashrc

%triggerpostun -- %{name} < 20081219-0.1
# don't do anything on --downgrade
if [ $1 -le 1 ]; then
	exit 0
fi
# No rpm in vservers
if [ ! -x /bin/rpm ]; then
	exit 0
fi

# This ugly trigger is here because we package same pathnames as ghost
# meaning the files will lay around from previous package version.

# get files which are ghost for us
files=$(rpm -ql %{name}-%{version}-%{release} | grep %{_sysconfdir}/bash_completion.d/)

# this is to get old pkg NVR, actually gives list of files that are
# packaged by other versions than this installed one, which is ok even for
# multiple bash-completion pkgs being installed.
oldpkg=$(rpm -qf $(echo "$files") 2>/dev/null | grep -v 'is not' | sort -u | grep -v %{name}-%{version}-%{release})
for a in $(rpm -ql $oldpkg | grep %{_sysconfdir}/bash_completion.d/); do
	# remove files from old package (which are ghost in new pkg),
	# if not already converted to symlink
	[ -L $a ] || rm -f $a
done

# Usage: bashcomp_trigger PACKAGENAME [SCRIPTNAME]
%define bashcomp_trigger() \
%triggerin -- %1\
if [ ! -L %{_sysconfdir}/bash_completion.d/%{?2}%{!?2:%1} ] ; then\
	ln -sf ../..%{_datadir}/%{name}/%{?2}%{!?2:%1} %{_sysconfdir}/bash_completion.d\
fi\
%triggerun -- %1\
[ $2 -gt 0 ] || rm -f %{_sysconfdir}/bash_completion.d/%{?2}%{!?2:%1}\
%{nil}

%bashcomp_trigger bitkeeper
%bashcomp_trigger BitTorrent bittorrent
%bashcomp_trigger cksfv
%bashcomp_trigger clisp
%bashcomp_trigger dsniff
%bashcomp_trigger freeciv-client,freeciv-server freeciv
%bashcomp_trigger gcc-ada gnatmake
%bashcomp_trigger gcl
%bashcomp_trigger gkrellm
%bashcomp_trigger gnupg2 gpg2
%bashcomp_trigger lilypond
%bashcomp_trigger mailman
%bashcomp_trigger mcrypt
%bashcomp_trigger mercurial hg
%bashcomp_trigger mtx
%bashcomp_trigger openssh-clients ssh
%bashcomp_trigger poldek
%bashcomp_trigger povray
%bashcomp_trigger QtDBus qdbus
%bashcomp_trigger ruby-modules ri
%bashcomp_trigger sbcl
%bashcomp_trigger sitecopy
%bashcomp_trigger snownews
%bashcomp_trigger svk
%bashcomp_trigger unace
%bashcomp_trigger unixODBC isql
%bashcomp_trigger unrar

%files -f %{name}-ghost.list
%defattr(644,root,root,755)
%doc README TODO debian/changelog debian/copyright
/etc/shrc.d/%{name}.sh
%{_sysconfdir}/bash_completion
%dir %{_sysconfdir}/bash_completion.d
%dir %{_datadir}/%{name}
# we list all files to be sure we have all of them handled by triggers
%{_datadir}/%{name}/bitkeeper
%{_datadir}/%{name}/bittorrent
%{_datadir}/%{name}/cksfv
%{_datadir}/%{name}/clisp
%{_datadir}/%{name}/dsniff
%{_datadir}/%{name}/freeciv
%{_datadir}/%{name}/gcl
%{_datadir}/%{name}/gkrellm
%{_datadir}/%{name}/gnatmake
%{_datadir}/%{name}/gpg2
%{_datadir}/%{name}/hg
%{_datadir}/%{name}/isql
%{_datadir}/%{name}/lilypond
%{_datadir}/%{name}/mailman
%{_datadir}/%{name}/mcrypt
%{_datadir}/%{name}/mtx
%{_datadir}/%{name}/poldek
%{_datadir}/%{name}/povray
%{_datadir}/%{name}/qdbus
%{_datadir}/%{name}/ri
%{_datadir}/%{name}/sbcl
%{_datadir}/%{name}/sitecopy
%{_datadir}/%{name}/snownews
%{_datadir}/%{name}/ssh
%{_datadir}/%{name}/svk
%{_datadir}/%{name}/unace
%{_datadir}/%{name}/unrar

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: bash-completion.spec,v $
Revision 1.143  2009/04/03 14:36:56  glen
- merged on demand install of completions from DEVEL; rel 2

Revision 1.142.2.4  2009/04/02 21:41:36  glen
- skip "upgrade" trigger on "downgrade"

Revision 1.142.2.3  2009/04/02 21:04:44  glen
- make relative symlinks (so they look good when browsing vserver/chroot)

Revision 1.142.2.2  2009/04/02 18:43:35  glen
- handles files to ghost conversion via trigger

Revision 1.142.2.1  2009/04/02 18:01:01  glen
- on demand completion install on triggers
- some problems with upgrade so commiting to DEVEL

Revision 1.142  2009/04/02 17:05:25  glen
- remove rpmpkgs.txt completely

Revision 1.141  2009/04/02 16:46:09  glen
- use hrmib-cache only in rpm complete

Revision 1.140  2009/04/02 16:04:57  glen
- new upstream, update to 20081219

Revision 1.139  2008/03/24 07:04:27  glen
- shorten, LC_ALL=C for sort only

Revision 1.138  2008-02-20 15:20:39  glen
- use /var/cache/hrmib dir contents in _rpm_installed_packages when available; rel 6

Revision 1.137  2008-01-09 21:10:25  glen
- define $cur early for poldek -e; rel 5

Revision 1.136  2008-01-08 01:11:46  glen
- always pass --nodigest --nosignature to rpm command; rel 4

Revision 1.135  2007-12-25 22:26:57  glen
- rel 3

Revision 1.134  2007-02-12 21:23:48  glen
- tabs in preamble

Revision 1.133  2007/02/12 00:48:39  baggins
- converted to UTF-8

Revision 1.132  2006/12/28 17:36:26  glen
- skins dir path for mplayer
- add *.flv to mplayer
- rel 2

Revision 1.131  2006/08/23 08:06:00  havner
- no 755 for /etc/shrc.d

Revision 1.130  2006/03/01 20:09:12  glen
- split and rediff patches for easier upstream merge
- move initialization script to SOURCES

Revision 1.129  2006/03/01 19:43:35  glen
- updated to 20060301
- subversion completion integrated into main file
- move shrc file creation to %prep

Revision 1.128  2006/02/22 19:01:20  glen
- drop -rpm-cache package (on demand caching in main code)
- rel 4, STBR

Revision 1.127  2006/01/18 00:06:44  glen
- add arch to rpm pkglist completion output

Revision 1.126  2006/01/17 11:20:00  glen
- 644,root,wheel for rpmpkgs.txt

Revision 1.125  2006/01/17 11:13:26  glen
- added completion for poldek

Revision 1.124  2006/01/03 19:38:27  glen
- updated rpmpkgs.txt patch to refresh cache when rpmdb is newer (improves performance); rel 3

Revision 1.123  2006/01/03 18:47:42  adamg
- fix for "sed: -e expression #1, char 20: unterminated `s' command" error
  occuring when trying to complete host while using ssh or scp
- patch by Maciej Mitura (emkwadrat (at) poczta.onet.pl)
- release 2

Revision 1.122  2005/08/10 15:10:51  charles
- reverted my last change

Revision 1.121  2005/08/09 21:50:59  glen
- check for interactive shell when loading bash completions

Revision 1.120  2005/08/09 21:25:07  charles
- giving off /etc/bash_completion.d (can be used through e.g. openoffice.org)

Revision 1.119  2005/07/21 22:09:02  glen
- 20050721

Revision 1.118  2005/07/20 10:00:08  glen
- 20050720

Revision 1.117  2005/07/12 20:22:52  glen
- 20050712

Revision 1.116  2005/05/31 17:26:16  glen
- fixed ifcfg patch
- rel 3
- STBR

Revision 1.115  2005/02/18 10:37:01  glen
- ifcfg arg parsing fixed
- just in case escape % marks when creating shrc file
- rel 2; STBR

Revision 1.114  2005/01/23 21:59:15  glen
- 20050121

Revision 1.113  2005/01/20 11:28:39  glen
- version 20050120
- load bash_completions from shrc.d, so they're loaded also for subshell

Revision 1.112  2005/01/13 13:07:13  glen
- no need to check for bash_completion existence, it's always there

Revision 1.111  2005/01/13 13:00:37  qboosh
- defattr for -rpm-cache

Revision 1.110  2005/01/13 12:54:41  glen
- update to 20050112
- do not modify /etc/bashrc, use /etc/profile.d/*.sh instead (see their homepage why)

Revision 1.109  2005/01/11 22:46:54  glen
- rel 2; STBR

Revision 1.108  2005/01/11 18:44:08  qboosh
- pl for -rpm-cache

Revision 1.107  2005/01/11 03:37:13  glen
- -rpm-cache subpackage

Revision 1.106  2005/01/04 14:58:29  adamg
- updated to 20050103

Revision 1.105  2004/11/05 10:40:37  paladine
- spaces->tabs
- cosmetics

Revision 1.104  2004/10/17 12:23:39  adamg
- updated to 20041017

Revision 1.103  2004/08/23 22:15:25  grzegol
- added support for bash >= 3.0
- rel. 3

Revision 1.102  2004/07/13 20:32:46  adamg
- don't include subversion completion file (conflicts with  subversion-tools
  package)
- release 2

Revision 1.101  2004/07/11 21:07:07  adamg
- updated to 20040711

Revision 1.100  2004/07/04 12:01:55  grzegol
- updated to 20040704

Revision 1.99  2004/05/26 11:01:07  grzegol
- updated to 20040526

Revision 1.98  2004/03/31 18:34:12  grzegol
- updated to 20040331

Revision 1.97  2004/02/15 10:53:21  adamg
- updated to 20040214

Revision 1.96  2004/02/10 13:49:52  grzegol
- updated to 20040210

Revision 1.95  2004/01/01 17:41:12  adamg
- updated to 20040101

Revision 1.94  2003/12/25 09:00:16  adamg
- updated to 20031225

Revision 1.93  2003/12/15 15:43:07  grzegol
- updated to 20031215

Revision 1.92  2003/11/25 22:25:30  grzegol
- updated to 20031125

Revision 1.91  2003/11/12 13:13:53  grzegol
- updated to 20031112

Revision 1.90  2003/10/28 10:45:17  adamg
- contrib/ files should be in %{_sysconfdir}/bash_completion.d not in
  %doc, so that we can use them.

Revision 1.89  2003/10/22 11:39:20  grzegol
- updated to 20031022

Revision 1.88  2003/10/08 16:35:53  grzegol
- updated to 20031007

Revision 1.87  2003/09/30 09:16:54  adamg
- updated to 20030929

Revision 1.86  2003/09/12 09:43:49  grzegol
- updated to 20030911

Revision 1.85  2003/08/21 11:23:20  grzegol
- updated to 20030821

Revision 1.84  2003/08/11 23:43:32  grzegol
- updated to 20030811

Revision 1.83  2003/08/06 16:32:51  kloczek
- może wrescie ktoś wykasuje to konto ?

Revision 1.82  2003/08/03 08:45:32  adamg
- updated to 20030803

Revision 1.81  2003/07/21 11:15:07  adamg
- updated to 20030721

Revision 1.80  2003/07/13 11:42:50  adamg
- added BUGS to %doc

Revision 1.79  2003/07/13 11:07:31  adamg
- updated to 20030713

Revision 1.78  2003/06/30 08:41:14  adamg
- updated to 20030630

Revision 1.77  2003/06/08 19:54:23  grzegol
- updated to 20030607

Revision 1.76  2003/05/28 08:01:23  adamg
- up 20030527
- added Source0-md5

Revision 1.75  2003/05/25 05:45:53  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.74  2003/05/17 20:33:10  grzegol
- updated to 20030505

Revision 1.73  2003/05/01 13:48:56  grzegol
- updated to 20030501

Revision 1.72  2003/04/19 16:30:34  adamg
- up to 20030419

Revision 1.71  2003/04/14 16:49:24  grzegol
- updated to 20030414

Revision 1.70  2003/03/27 16:55:34  grzegol
- updated to 20030327

Revision 1.69  2003/02/28 15:12:45  grzegol
- updated to 20030227

Revision 1.68  2003/02/11 14:12:09  grzegol
- updated to 20030209

Revision 1.67  2003/02/02 18:48:56  grzegol
- updated to 20030201
- removed obsolette patch (already in sources)

Revision 1.66  2003/01/28 14:14:04  grzegol
- added cvs_completion_fix patch
- rel. 2

Revision 1.65  2003/01/27 19:25:45  grzegol
- updated to 20030126

Revision 1.64  2003/01/19 12:45:55  areq
- 20030118. STBR

Revision 1.63  2003/01/15 15:25:28  areq
- 20030113, STBR

Revision 1.62  2002/12/31 19:17:56  areq
-  20021231, STBR

Revision 1.61  2002/12/29 01:44:29  qboosh
- umask in scripts, other fixes/cosmetics where needed

Revision 1.60  2002/12/24 11:41:59  grzegol
- updated to 20021223

Revision 1.59  2002/12/21 18:32:56  grzegol
- updated to 20021221

Revision 1.58  2002/12/17 12:04:52  areq
- 20021217, STBR

Revision 1.57  2002/12/13 14:39:43  areq
- 20021213, STBR

Revision 1.56  2002/12/06 09:58:07  areq
- 20021205, STBR

Revision 1.55  2002/10/26 12:37:18  grzegol
- updated to 20021026

Revision 1.54  2002/10/23 21:20:56  grzegol
- updated to 20021022

Revision 1.53  2002/10/21 14:25:59  areq
- 20021021, STBR

Revision 1.52  2002/10/17 11:49:17  grzegol
- upfated to 20021017

Revision 1.51  2002/10/16 17:16:52  grzegol
- updated to 20021013

Revision 1.50  2002/10/08 11:21:48  grzegol
- updated to 20021007

Revision 1.49  2002/10/05 14:01:10  areq
- 20021005, STBR

Revision 1.48  2002/10/01 12:29:39  grzegol
- updated to 20021001

Revision 1.47  2002/09/28 21:35:25  areq
- 20020928, STBR

Revision 1.46  2002/09/09 19:59:15  grzegol
- updated to 20020909

Revision 1.45  2002/08/20 12:47:10  areq
- 20020819, STBR

Revision 1.44  2002/08/12 21:39:17  klark
- update to 20020812

Revision 1.43  2002/08/06 23:00:18  grzegol
- updated to 20020803

Revision 1.42  2002/07/27 21:17:00  grzegol
- updated to 20020727

Revision 1.41  2002/07/23 22:33:33  grzegol
- updated to 20020723

Revision 1.40  2002/07/16 12:39:29  grzegol
- updated to 20020716

Revision 1.39  2002/07/11 16:20:45  grzegol
- updated to 20020711

Revision 1.38  2002/07/04 12:58:27  grzegol
- updated to 20020704
- compress all %doc

Revision 1.37  2002/06/26 14:11:56  grzegol
- updated to 20020626

Revision 1.36  2002/06/24 19:20:21  grzegol
- updated to 20020624

Revision 1.35  2002/06/21 15:40:11  grzegol
- updated to 20020621

Revision 1.34  2002/06/19 14:05:29  grzegol
- updated to 20020619

Revision 1.33  2002/06/17 11:20:11  grzegol
- updated to 20020616

Revision 1.32  2002/06/12 12:27:22  grzegol
- updated to 20020611

Revision 1.31  2002/06/10 10:05:14  grzegol
- updated to 20020609

Revision 1.30  2002/06/05 14:43:00  grzegol
- updated to 20020605

Revision 1.29  2002/06/01 21:45:05  klark
- update to 20020601

Revision 1.28  2002/05/30 17:59:41  grzegol
- updated to 20020528

Revision 1.27  2002/05/26 14:54:58  grzegol
- added content of contrib to doc (it was deleted while changing to new %doc)
- rel. 2

Revision 1.26  2002/05/21 18:56:39  klark
- add correct mode to /etc/bashrc in %postun

Revision 1.25  2002/05/21 18:38:43  klark
- update to 20020521
- new %doc
- STBR

Revision 1.24  2002/05/19 19:39:20  klark
- update to 20020519

Revision 1.23  2002/05/16 20:20:27  grzegol
- updated to 20020516

Revision 1.22  2002/05/14 18:25:39  klark
- upgrade to 20020514

Revision 1.21  2002/05/11 18:27:18  pioklo
- up to 20020511, STBR

Revision 1.20  2002/05/09 05:57:52  kloczek
- cosmetics.

Revision 1.19  2002/05/07 11:38:33  grzegol
- updated to 20020507

Revision 1.18  2002/05/04 21:26:46  klark

- updated to 20020504

Revision 1.17  2002/04/30 18:08:51  grzegol
- updated to 20020430

Revision 1.16  2002/04/28 15:41:33  grzegol
- updated to 20020427

Revision 1.15  2002/04/22 13:05:06  grzegol
- updated to 20020422
- removed bash-completion-man-fix.patch (fixed in sources)

Revision 1.14  2002/04/19 20:20:03  grzegol
- added bash-completion-man-fix.patch
- rel. 2

Revision 1.13  2002/04/18 17:07:12  pioklo
- update, STBR

Revision 1.12  2002/04/13 20:20:18  grzegol
- updated to 20020413

Revision 1.11  2002/04/08 19:52:34  grzegol
- updated to 20020408

Revision 1.10  2002/04/07 10:05:04  grzegol
- updated to 20020406

Revision 1.9  2002/04/05 14:57:40  pioklo
- updated to version 20020404 ,STBR

Revision 1.8  2002/04/03 20:46:31  grzegol
- quoted variables in bashrc
- rel. 2

Revision 1.7  2002/04/02 13:09:46  qboosh
- pl summary, typo, standard changelog headers

Revision 1.6  2002/04/02 12:26:27  pioklo
- upgrade and fix changelog

Revision 1.5  2002/04/01 11:48:29  grzegol
- updated to 20020331
- fixed descriptions
- adapterized

Revision 1.4  2002/04/01 10:51:29  pioklo
- cosmetics

Revision 1.3  2002/03/29 12:48:00  pioklo
- now Requires bash-2.05a-3

Revision 1.2  2002/03/29 12:08:20  pioklo
- typo

Revision 1.1  2002/03/29 11:12:37  pioklo
- new PLD spec
- to work need added patch do bash bash-2.05a-service_completion.patch
- STBR
